Bug 528303 - [ml_IN] Reordering of Malayalam Rakar not working properly
[ml_IN] Reordering of Malayalam Rakar not working properly
Status: CLOSED ERRATA
Product: Fedora
Classification: Fedora
Component: qt (Show other bugs)
14
All Linux
low Severity medium
: ---
: ---
Assigned To: Ngo Than
Fedora Extras Quality Assurance
:
Depends On:
Blocks: 562132
  Show dependency treegraph
 
Reported: 2009-10-11 01:25 EDT by Santhosh Thottingal
Modified: 2013-10-04 08:19 EDT (History)
15 users (show)

See Also:
Fixed In Version: qt-4.7.1-3.fc14
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
: 562132 (view as bug list)
Environment:
Last Closed: 2010-11-28 15:43:01 EST
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:


Attachments (Terms of Use)
Comparison of rendering in kde and gnome (16.67 KB, image/png)
2009-10-11 01:25 EDT, Santhosh Thottingal
no flags Details
Screenshot for Meera on gedit, kwrite and oowriter (correct) (159.27 KB, image/png)
2009-10-12 10:53 EDT, Ani Peter
no flags Details
Screenshot for Lohit Malayalam on gedit, kwrite and oowriter (168.25 KB, image/png)
2009-10-12 10:54 EDT, Ani Peter
no flags Details
Screenshot for Raghu Malayalam on gedit, kwrite and oowriter (correct) (170.83 KB, image/png)
2009-10-12 10:56 EDT, Ani Peter
no flags Details
Screenshot for Kalyani on gedit, kwrite and oowriter (167.77 KB, image/png)
2009-10-14 02:56 EDT, Ani Peter
no flags Details
Screenshot for Samyak Malayalam on gedit, kwrite and oowriter (175.14 KB, image/png)
2009-10-14 02:57 EDT, Ani Peter
no flags Details
Lookup table for Lohit Malayalam font (1.73 KB, application/octet-stream)
2009-10-20 06:27 EDT, Suresh P
no flags Details
Patch fixing Malayalam Ra-kar rendering (939 bytes, patch)
2010-11-19 12:23 EST, Rajeesh
no flags Details | Diff
Screen shot for kwrite with correct rendering (144.03 KB, image/png)
2010-11-26 07:01 EST, Ani Peter
no flags Details


External Trackers
Tracker ID Priority Status Summary Last Updated
Qt Bug Tracker QTBUG-1887 None None None Never

  None (edit)
Description Santhosh Thottingal 2009-10-11 01:25:28 EDT
Created attachment 364359 [details]
Comparison of rendering in kde and gnome

Description of problem:
The lohit font 2.4.4 version gives wrong redering in KDE for cons + virama + ra sequence. 
See the attached screenshot.
The prebase ra sign becomes postbase in KDE applications, while in GNOME applications it is correct.

Version-Release number of selected component (if applicable):
Lohit 2.4.4
KDE 4.3.2

How reproducible:
Always

Steps to Reproduce:
1. Compare the rendering of പ്രഭാതം, അക്രമം, സൂത്രം etc in gedit and kate
  
Actual results:
See the attached screenshot

Expected results:
See the attached screenshot


Additional info:
Comment 1 Ani Peter 2009-10-12 10:53:54 EDT
Created attachment 364475 [details]
Screenshot  for Meera on gedit, kwrite and oowriter (correct)

Done some testing on the bug and following are the observations:
1. the issue with cons + virama + ra (ie, cons + 0D4D + 0D30) exists only with Lohit Malayalam
2. Lohit Malayalam works perfect with Gedit (pango), but has issues in Kwrite (Qt) and oowriter (icu).
3. As Lohit Malayalam is a new script font, tested with another new script font - Raghu Malayalam and confirmed that the issue exists only with Lohit Malayalam.
Please find attached the screenshots of Meera (traditional script font), Lohit Malayalam and Raghu Malayalam (both new script fonts) on gedit, oowriter and kwrite. Have mentioned the versions of the rendering engine on screenshots.

Following are the words used for rendering:
1. പ്രാധാന്യം
2. സുപ്രഭാതം
3. അക്രമം
4. സൂത്രം
Comment 2 Ani Peter 2009-10-12 10:54:59 EDT
Created attachment 364476 [details]
Screenshot  for Lohit Malayalam on gedit, kwrite and oowriter

Lohit Malayalam working correctly on gedit, but have issue with kwrite and oowriter
Comment 3 Ani Peter 2009-10-12 10:56:07 EDT
Created attachment 364477 [details]
Screenshot  for Raghu Malayalam on gedit, kwrite and oowriter  (correct)

Raghu Malayalam works correctly on gedit, kwrite and oowriter.
Comment 4 Ani Peter 2009-10-14 02:55:43 EDT
I have done testing with two more new script fonts - Kalyani and Samyak Malayalam
These fonts also face similar problems in qt, icu and works perfect with gedit. Screenshots attached.

Conclusion: 
1. The problem reported in this bug is about Lohit Malayalam with KDE (qt)
2. The same problem exists for Lohit Malayalam with oowriter (icu)
3. Two other fonts - (i) Samyak Malayalam and (ii) Kalyani also has similar issue with both qt and icu

Hence please advise how to go about with this bug and against which components above bugs should be filed.
Comment 5 Ani Peter 2009-10-14 02:56:35 EDT
Created attachment 364702 [details]
Screenshot  for Kalyani on gedit, kwrite and oowriter
Comment 6 Ani Peter 2009-10-14 02:57:07 EDT
Created attachment 364703 [details]
Screenshot  for Samyak Malayalam on gedit, kwrite and oowriter
Comment 7 Pravin Satpute 2009-10-14 03:41:25 EDT
IMO this is not a font bug

Malayalam script require reordering of OD4d OD30 (rakar) by rendering engine, same is handled in pango, looks something is changed in Harfbuzz and ICU.

Same thing working in RaghuMalayalam fonts since it provided ligature (complete glyph) for rakar combination.
try some other rakar combination you will understand difference
Comment 8 Nicolas Mailhot 2009-10-14 03:46:08 EDT
(In reply to comment #4)

> Hence please advise how to go about with this bug and against which components
> above bugs should be filed.  

Please open a qt or kde bug (here and upstream) and an OO.o but (here and upstream) cc-ing fedora-fonts-bugs-list at redhat.com

You should also test java (jedit) as it's the third major component that tends to have text rendering problems.

(it would of course be interesting to find a workaround in lohit, but when 3 different fonts fail the same way, that means the text libraries have a big problem)
Comment 9 Pravin Satpute 2009-10-14 06:21:08 EDT
(In reply to comment #8)
> 
> (it would of course be interesting to find a workaround in lohit, but when 3
> different fonts fail the same way, that means the text libraries have a big
> problem)  

we can fix this in lohit as well but i think need to add something around 60 ligature

i.e 37 (cons) + [0d4d + 0d30] = ligature

+

37 (cons)+ 0d4d + 37 (cons) + [0d4d + 0d30] = ligature

some or many out of these will be not require. 
I have tested with some font on windows, Uniscribe is doing reordering for this.

sometime i feel we should have at least one font for each language with AAT, which will make rendering independent of rendering engine
Comment 10 Ani Peter 2009-10-14 07:13:24 EDT
Based on all discussions, I understand the issue is with the rendering engines. Hence,
(i) changing the component of this bug to Qt 
(ii) changing summary accordingly and
(iii) opening another bug for icu.
Comment 11 Suresh P 2009-10-20 06:24:31 EDT
I have prepared a lookup table for Lohit Malayalam which can sort out some issues connected with xRA forms which can be merged with feature info of the font. The remaining things are related to the incorrectly substituted post-base RA form for bases like LA,YA,LLA etc. There is no xRA forms for these consonants as per the orthography. Re-ordering the RA form as pre-base makes the text readable even though it goes against orthographic rules. But Harfbuzz and ICU are not doing this. These issues can be solved if the new version of Opentype specs are implemented correctly.
Comment 12 Suresh P 2009-10-20 06:27:20 EDT
Created attachment 365322 [details]
Lookup table for Lohit Malayalam font

Lookup table to be merged with Lohit Malayalam font is attached.
Comment 13 Ani Peter 2009-10-20 13:33:02 EDT
Have filed  Bug 529905 reporting the same issue with icu. Will test in jedit asap and do the needful.
thanks

(In reply to comment #8)
> (In reply to comment #4)
> 
> > Hence please advise how to go about with this bug and against which components
> > above bugs should be filed.  
> 
> Please open a qt or kde bug (here and upstream) and an OO.o but (here and
> upstream) cc-ing fedora-fonts-bugs-list at redhat.com
> 
> You should also test java (jedit) as it's the third major component that tends
> to have text rendering problems.
> 
> (it would of course be interesting to find a workaround in lohit, but when 3
> different fonts fail the same way, that means the text libraries have a big
> problem)
Comment 14 Bug Zapper 2009-11-16 08:29:44 EST
This bug appears to have been reported against 'rawhide' during the Fedora 12 development cycle.
Changing version to '12'.

More information and reason for this action is here:
http://fedoraproject.org/wiki/BugZappers/HouseKeeping
Comment 15 Pravin Satpute 2010-05-13 01:54:42 EDT
see od15 od4d od30 
moving to qt as same is working well with pango

i am sure harfbuzz will help lot in this
Comment 16 Praveen Arimbrathodiyil 2010-05-24 07:39:49 EDT
Rajeesh has prepared a patch for this and submitted to qt upstream

http://bugreports.qt.nokia.com/browse/QTBUG-1887
Comment 17 Bug Zapper 2010-11-04 05:32:01 EDT
This message is a reminder that Fedora 12 is nearing its end of life.
Approximately 30 (thirty) days from now Fedora will stop maintaining
and issuing updates for Fedora 12.  It is Fedora's policy to close all
bug reports from releases that are no longer maintained.  At that time
this bug will be closed as WONTFIX if it remains open with a Fedora 
'version' of '12'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version' 
to a later Fedora version prior to Fedora 12's end of life.

Bug Reporter: Thank you for reporting this issue and we are sorry that 
we may not be able to fix it before Fedora 12 is end of life.  If you 
would still like to see this bug fixed and are able to reproduce it 
against a later version of Fedora please change the 'version' of this 
bug to the applicable version.  If you are unable to change the version, 
please add a comment here and someone will do it for you.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events.  Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.

The process we are following is described here: 
http://fedoraproject.org/wiki/BugZappers/HouseKeeping
Comment 18 Ani Peter 2010-11-16 08:52:40 EST
The reported issue with Lohit Malayalam, Kalyani and Samyak Malayalam still exists. Confirmed in F14.
Thanks!
Comment 19 Praveen Arimbrathodiyil 2010-11-16 09:29:43 EST
There was some activity on this bug in upstream bug tracker. The changes are proposed to be included in qt 4.7.2. We have test the upstream version to confirm if the fixes are included.
Comment 20 Pravin Satpute 2010-11-19 01:36:50 EST
upstream has accepted the patch and will be release in 4.7.2
Than,
   is there any chance to get this release in f14?, if not we should try and patch in 4.7.1 (in rawhide), so we will get some testing prior to 4.7.2 release.

Rajeesh,

  can you submit patch here as well?
Comment 21 Rajeesh 2010-11-19 12:23:55 EST
Created attachment 461606 [details]
Patch fixing Malayalam Ra-kar rendering

Patch is attached.
Comment 22 Ani Peter 2010-11-22 02:49:35 EST
Rajeesh thanks a lot for the patch.

Than, would really appreciate if you could help us in getting this patch included for f15 as this is really important for our language. Thanks for your understanding. :)
Comment 23 Ngo Than 2010-11-22 06:19:19 EST
i will rebuild qt-4.7.1 with this patch for f14 and rawhide today. thanks for the patch
Comment 24 Fedora Update System 2010-11-23 10:08:17 EST
qt-4.7.1-2.fc14 has been submitted as an update for Fedora 14.
https://admin.fedoraproject.org/updates/qt-4.7.1-2.fc14
Comment 25 Fedora Update System 2010-11-23 16:56:38 EST
qt-4.7.1-2.fc14 has been pushed to the Fedora 14 testing repository.  If problems still persist, please make note of it in this bug report.
 If you want to test the update, you can install it with 
 su -c 'yum --enablerepo=updates-testing update qt'.  You can provide feedback for this update here: https://admin.fedoraproject.org/updates/qt-4.7.1-2.fc14
Comment 26 Fedora Update System 2010-11-25 20:10:22 EST
qt-4.7.1-3.fc14 has been pushed to the Fedora 14 testing repository.  If problems still persist, please make note of it in this bug report.
 If you want to test the update, you can install it with 
 su -c 'yum --enablerepo=updates-testing update qt'.  You can provide feedback for this update here: https://admin.fedoraproject.org/updates/qt-4.7.1-3.fc14
Comment 27 Ani Peter 2010-11-26 07:01:57 EST
Created attachment 463067 [details]
Screen shot for kwrite with correct rendering

Tested from f14 testing repo. The rendering is perfect now. Thanks once again for the patch Rajeesh. 

Than, thanks to you too for all the help.
Comment 28 Fedora Update System 2010-11-28 15:42:49 EST
qt-4.7.1-3.fc14 has been pushed to the Fedora 14 stable repository.  If problems still persist, please make note of it in this bug report.
Comment 29 Red Hat Bugzilla 2013-10-03 20:18:37 EDT
Removing external tracker bug with the id '1887' as it is not valid for this tracker

Note You need to log in before you can comment on or make changes to this bug.